#pragma once

#include "aliases.h"

typedef struct event_system EventSystem;
struct event_system {
  u64 id;
};

typedef struct event Event;
struct event {
  u64 id;
  u64 system;
};

typedef struct event_listener EventListener;
struct event_listener {
  Event event;
  u64 id;
};

typedef void (*EventCallback)(void *data);

EventSystem   es_init(u64 initial_event_capacity, u64 initial_listeners_capacity);
void          es_deinit(EventSystem *event_system);
Event         es_register_event(EventSystem *event_system);
void          es_deregister_event(EventSystem event_system, Event *event);
EventListener es_add_event_listener(EventSystem *event_system, Event event, EventCallback callback);
void          es_remove_event_listener(EventSystem event_system, EventListener listener);
void          es_emit_event(EventSystem event_system, Event event, void *data);
